apiVersion: apps/v1
kind: Deployment
metadata:
  name: $ENVIRONMENT_NAME
spec:
  selector:
    matchLabels:
      app: $ENVIRONMENT_NAME
  replicas: 1
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 25%
      maxUnavailable: 25%
  template:
    metadata:
      labels:
        app: $ENVIRONMENT_NAME
    spec:
      imagePullSecrets:
        - name: regcred
      containers:
        - name: $ENVIRONMENT_NAME
          imagePullPolicy: Always
          image: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:latest
          ports:
            - containerPort: 8080
          env:
            - name: CLUSTER_MODE
              value: 'true'
            - name: PORT
              value: "8080"
---
apiVersion: v1
kind: Service
metadata:
  name: $ENVIRONMENT_NAME
spec:
  selector:
    app: $ENVIRONMENT_NAME
  ports:
    - protocol: TCP
      port: 8080
      targetPort: 8080
---
apiVersion: cert-manager.io/v1
kind: Certificate
metadata:
  name: $ENVIRONMENT_NAME
spec:
  secretName: $ENVIRONMENT_NAME
  dnsNames:
    - $ENVIRONMENT_NAME.$BASE_HOST
  issuerRef:
    name: letsencrypt-prod
    kind: ClusterIssuer
    group: cert-manager.io
---
apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
  name: $ENVIRONMENT_NAME
  annotations:
    nginx.ingress.kubernetes.io/http2-push-preload: 'true'
    cert-manager.io/cluster-issuer: 'letsencrypt-prod'
    kubernetes.io/ingress.class: 'nginx-cert'
    nginx.ingress.kubernetes.io/ssl-redirect: 'false'
    nginx.ingress.kubernetes.io/rewrite-target: /
spec:
  tls:
    - secretName: $ENVIRONMENT_NAME
      hosts:
        - $ENVIRONMENT_NAME.$BASE_HOST
  rules:
    - host: $ENVIRONMENT_NAME.$BASE_HOST
      http:
        paths:
          - path: /
            pathType: Prefix
            backend:
              service:
                name: $ENVIRONMENT_NAME
                port:
                  number: 8080
